/************************************************************************
 *
 * Copyright (C) 2009-2016 IRCAD France
 * Copyright (C) 2012-2016 IHU Strasbourg
 *
 * This file is part of Sight.
 *
 * Sight is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Sight is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sight. If not, see <https://www.gnu.org/licenses/>.
 *
 ***********************************************************************/

#ifndef __FWDATACAMP_MATERIAL_HPP__
#define __FWDATACAMP_MATERIAL_HPP__

#include <fwCamp/macros.hpp>
#include <fwData/Material.hpp>

#include "fwDataCamp/config.hpp"

fwCampAutoDeclareEnumMacro((fwData)(Material)(ShadingType));
fwCampAutoDeclareEnumMacro((fwData)(Material)(RepresentationType));
fwCampAutoDeclareEnumMacro((fwData)(Material)(OptionsType));
fwCampAutoDeclareEnumMacro((fwData)(Material)(FilteringType));
fwCampAutoDeclareEnumMacro((fwData)(Material)(WrappingType));

fwCampDeclareAccessor((fwData)(Material), (fwData)(Color));
fwCampDeclareAccessor((fwData)(Material), (fwData)(Image));

#endif /* __FWDATACAMP_MATERIAL_HPP__ */
